#include <new>

#include "pc6001v.h"
#include "pc60.h"
#include "error.h"

#include "ini.h"

#include "breakpoint.h"
#include "common.h"
#include "cpum.h"
#include "cpus.h"
#include "debug.h"
#include "disk.h"
#include "graph.h"
#include "intr.h"
#include "io.h"
#include "keyboard.h"
#include "memory.h"
#include "osd.h"
#include "pio.h"
#include "psg.h"
#include "schedule.h"
#include "sound.h"
#include "status.h"
#include "tape.h"
#include "voice.h"
#include "usrevent.h"
#include "vdg.h"




////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
VM6::VM6( void )
{
	UDFPSCount = 0;		// FPS\^C}JE^
	FSkipCount = 0;		// t[XLbvJE^
	
	cfg		= NULL;
	io		= NULL;
	ios		= NULL;
	sche	= NULL;
	snd		= NULL;
	psg		= NULL;
	mem		= NULL;
	vdg		= NULL;
	graph	= NULL;
	intr	= NULL;
	cpum	= NULL;
	disk	= NULL;
	cmt		= NULL;
	cmts	= NULL;
	cpus	= NULL;
	pio		= NULL;
	key		= NULL;
	joy     = NULL;
	voice   = NULL;
	
	staw    = NULL;
	
	UpDateFPSID	= NULL;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	bp      = NULL;
	regw	= NULL;
	memw	= NULL;
	monw	= NULL;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// pbg
	ZeroMemory( GPal, sizeof(COLOR24)*256 );
	
	// L[͖
	ZeroMemory( &ak, sizeof( AKEY ) );

}

VM60::VM60( void ){}
VM62::VM62( void ){}
VM66::VM66( void ){}



////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
VM6::~VM6( void )
{
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( monw )   delete monw;
	if( memw )   delete memw;
	if( regw )   delete regw;
	if( bp )     delete bp;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	if( UpDateFPSID ) SDL_RemoveTimer( UpDateFPSID );
	
	if( staw )   delete staw;
	
	if( voice )  delete voice;
	if( joy )    delete joy;
	if( key )    delete key;
	if( pio )    delete pio;
	if( cpus )   delete cpus;
	if( cmts )   delete cmts;
	if( cmt )    delete cmt;
	if( disk )   delete disk;
	if( cpum )   delete cpum;
	if( intr )   delete intr;
	if( graph )  delete graph;
	if( vdg )    delete vdg;
	if( mem )    delete mem;
	if( psg )    delete psg;
	if( snd )    delete snd;
	if( sche )   delete sche;
	if( ios )    delete ios;
	if( io )     delete io;
	
	// R\[ptHgj
	JFont::CloseFont();
	
	// L[̓obt@j
	if( ak.Buffer ) delete [] ak.Buffer;
}

VM60::~VM60( void ){}
VM62::~VM62( void ){}
VM66::~VM66( void ){}



////////////////////////////////////////////////////////////////
// Xbh֐(I[o[Ch)
////////////////////////////////////////////////////////////////
void VM6::OnThread( void *inst )
{
	VM6 *p6;
	
	p6 = (VM6 *)inst;	// g̃IuWFNg|C^擾
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( p6->cfg->GetMonDisp() ){
	// j^[h
		while( !this->cThread::IsCancel() ){
			// ʍXV
			if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
			p6->sche->VWait();		// EFCg
		}
	}else
	// ʏ탂[h
		if( bp->ExistBreakPoint() ){
			// u[N|Cg
			while( !this->cThread::IsCancel() ){
				p6->Emu();		// 1ߎs
				
				if( p6->sche->IsVSYNC() ){
					// m[EFCg̃L[X|X悭邽
					// IɃCxgݏグ
					SDL_PumpEvents();
					p6->key->ScanMatrix();	// L[}gNXXL
					
					// TEhXV
					p6->SoundUpdate( 0 );
					// ʍXV
					if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
					p6->sche->VWait();		// EFCg
				}
				
				// u[N|Cg`FbN
				if( bp->CheckBreakPoint( BPoint::BP_PC, cpum->GetPC(), 0, NULL ) || bp->IsReqBreak() ){
					this->cThread::Cancel();	// XbhItOĂ
					bp->ResetBreak();
					SENDEVENT1( SDL_DEBUGMODEBP, cpum->GetPC() )
				}
			}
		}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{	// ʏs
		while( !this->cThread::IsCancel() ){
			// m[EFCg̃L[X|X悭邽
			// IɃCxgݏグ
			SDL_PumpEvents();
			
			
			// vCĐ
			if( REPLAY::GetStatus() == REP_REPLAY )
				REPLAY::ReplayReadFrame( p6->key->GetMatrix() );
			
			// L[}gNXXL
			BOOL matchg = p6->key->ScanMatrix();
			
			// vCL^
			if( REPLAY::GetStatus() == REP_RECORD )
				REPLAY::ReplayWriteFrame( p6->key->GetMatrix2(), matchg );
			
			
			p6->EmuVSYNC();			// 1ʕs
			
			// rfILv`?
			if( AVI6::IsAVI() ){
				// rfILv`Ȃ炱AVIۑ
				// TEhXV
				p6->SoundUpdate( 0, AVI6::GetAudioBuffer() );
				// ʍXV
				BOOL update = p6->ScreenUpdate();
				// ʍXVĂ AVI1ʕۑ
				if( update ) AVI6::AVIWriteFrame( p6->graph->GetSubBuffer() );
			}else{
				// rfILv`łȂȂʏ̍XV
				// TEhXV
				p6->SoundUpdate( 0 );
				// ʍXV
				// ʍXV}ĂʍXV
				// m[EFCg̎FPSςȂ悤ɂ
				if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
			}
			
			// L[
			if( IsAutoKey() ){
				BYTE key = GetAutoKey();
				if( key ) p6->cpus->ReqKeyIntr( 0, key );
			}
			
			p6->sche->VWait();		// EFCg
		}
	}
}


////////////////////////////////////////////////////////////////
// WaitL?
////////////////////////////////////////////////////////////////
BOOL VM6::IsWaitEnable( void )
{
	return sche->GetWaitEnable() && (!cfg->GetTurboTAPE() || (cpus->GetCmtStatus() == CMTCLOSE));
}


////////////////////////////////////////////////////////////////
// 1ߎs
////////////////////////////////////////////////////////////////
int VM6::Emu( void )
{
	int state = cpum->Exec();	// CPU 1ߎs
	sche->Update( state );		// CxgXV
	
	return state;
}


////////////////////////////////////////////////////////////////
// 1ʕs
////////////////////////////////////////////////////////////////
int VM6::EmuVSYNC( void )
{
	int state = 0;
	
	// VSYNC܂ŌJԂ
	while( !sche->IsVSYNC() ){
		int st = cpum->Exec();	// CPU 1ߎs
		sche->Update( st );		// CxgXV
		state += st;
	}
	
	return state;
}


#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
////////////////////////////////////////////////////////////////
// wXe[gs
////////////////////////////////////////////////////////////////
void VM6::Exec( int st )
{
	int State = st;
	
	while( State > 0 ) State -= Emu();
}


////////////////////////////////////////////////////////////////
// j^[hؑւ
////////////////////////////////////////////////////////////////
BOOL VM6::ToggleMonitor( void )
{
	// VM~
	Stop();
	
	// j^EBhE\Ԑ؊
	cfg->SetMonDisp( cfg->GetMonDisp() ? FALSE : TRUE );
	
	// j^[hȂUnicodeL
	SDL_EnableUNICODE( cfg->GetMonDisp() ? 1 : 0 );
	
	// u[N|Cg̏NA
	bp->ClearStatus();
	
	// XN[TCYύX
	graph->ResizeScreen();
	
	// VMĊJ
	Start();
	
	return cfg->GetMonDisp();
}
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL VM60::Init( const cConfig *config )
{
	// G[bZ[Wl
	Error::SetError( Error::InitFailed );
	
	if( !config ) return FALSE;
	cfg = (cConfig *)config;
	
	// eIuWFNgm
	intr   = new INT60( this, DEV_ID('I', 'N', 'T', 'R') );		// 
	sche   = new SCH6 ( this, DEV_ID('S', 'C', 'H', 'E'), CPUM_CLOCK60 * cfg->GetOverClock() / 100 );		// XPW[
	mem    = new MEM60( DEV_ID('M', 'E', 'M', '1'), cfg->GetUseExtRam() );		// 
	vdg    = new VDG60( this, DEV_ID('V', 'D', 'G', '1') );		// VDG
	key    = new KEY60( this, DEV_ID('K', 'E', 'Y', 'B') );		// L[
	disk   = new DSK60( this, DEV_ID('D', 'I', 'S', 'K'), cfg->GetFddNum() );	// DISK
	
	if( !intr || !sche || !mem || !vdg || !key || !disk )
		return FALSE;
	
	// ʕ
	if( !VM6::InitCommon() ) return FALSE;
	
	// eIuWFNgƃfoCXڑ
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, INT60::outB0H },
		{ 0xb1, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xb2, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xb3, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xb4, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xb5, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xb6, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xb7, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xb8, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xb9, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xba, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xbb, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xbc, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xbd, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xbe, IOBus::portout, INT60::outB0H },	// C[W
		{ 0xbf, IOBus::portout, INT60::outB0H },	// C[W
		{ 0, 0, 0 }	};
	if( !io->Connect( (INT60*)intr, c_intr ) ) return FALSE;
	
	// VDG -----
	const static IOBus::Connector c_vdg[] = {
		{ 0xb0, IOBus::portout, VDG60::outB0H },
		{ 0xb1, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xb2, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xb3, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xb4, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xb5, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xb6, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xb7, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xb8, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xb9, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xba, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xbb, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xbc, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xbd, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xbe, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0xbf, IOBus::portout, VDG60::outB0H },	// C[W
		{ 0, 0, 0 } };
	if( !io->Connect( (VDG60*)vdg, c_vdg ) ) return FALSE;
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, PSG6::outA0H },
		{ 0xa1, IOBus::portout, PSG6::outA1H },
		{ 0xa3, IOBus::portout, PSG6::outA3H },
		{ 0xa4, IOBus::portout, PSG6::outA0H },	// C[W
		{ 0xa5, IOBus::portout, PSG6::outA1H },	// C[W
		{ 0xa7, IOBus::portout, PSG6::outA3H },	// C[W
		{ 0xa8, IOBus::portout, PSG6::outA0H },	// C[W
		{ 0xa9, IOBus::portout, PSG6::outA1H },	// C[W
		{ 0xab, IOBus::portout, PSG6::outA3H },	// C[W
		{ 0xac, IOBus::portout, PSG6::outA0H },	// C[W
		{ 0xad, IOBus::portout, PSG6::outA1H },	// C[W
		{ 0xaf, IOBus::portout, PSG6::outA3H },	// C[W
		{ 0xa2, IOBus::portin,  PSG6::inA2H },
		{ 0xa6, IOBus::portin,  PSG6::inA2H },	// C[W
		{ 0xaa, IOBus::portin,  PSG6::inA2H },	// C[W
		{ 0xae, IOBus::portin,  PSG6::inA2H },	// C[W
		{ 0, 0, 0 }	};
	if( !io->Connect( psg, c_psg ) ) return FALSE;
	int i=0;
	while( c_psg[i].bank ){						// EFCgݒ
		if( c_psg[i].rule == IOBus::portout ) io->SetOutWait( c_psg[i].bank, 1 );
		else								  io->SetInWait( c_psg[i].bank, 1 );
		i++;
	}
	if( !psg->Init( PSG_CLOCK60, snd->GetSampleRate() ) ) return FALSE;
	
	// 8255(Z80) -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, PIO6::out90H },
		{ 0x91, IOBus::portout, PIO6::out91H },
		{ 0x92, IOBus::portout, PIO6::out92H },
		{ 0x93, IOBus::portout, PIO6::out93H },
		{ 0x94, IOBus::portout, PIO6::out90H },	// C[W
		{ 0x95, IOBus::portout, PIO6::out91H },	// C[W
		{ 0x96, IOBus::portout, PIO6::out92H },	// C[W
		{ 0x97, IOBus::portout, PIO6::out93H },	// C[W
		{ 0x98, IOBus::portout, PIO6::out90H },	// C[W
		{ 0x99, IOBus::portout, PIO6::out91H },	// C[W
		{ 0x9a, IOBus::portout, PIO6::out92H },	// C[W
		{ 0x9b, IOBus::portout, PIO6::out93H },	// C[W
		{ 0x9c, IOBus::portout, PIO6::out90H },	// C[W
		{ 0x9d, IOBus::portout, PIO6::out91H },	// C[W
		{ 0x9e, IOBus::portout, PIO6::out92H },	// C[W
		{ 0x9f, IOBus::portout, PIO6::out93H },	// C[W
		{ 0x90, IOBus::portin,  PIO6::in90H },
		{ 0x92, IOBus::portin,  PIO6::in92H },
		{ 0x93, IOBus::portin,  PIO6::in93H },
		{ 0x94, IOBus::portin,  PIO6::in90H },	// C[W
		{ 0x96, IOBus::portin,  PIO6::in92H },	// C[W
		{ 0x97, IOBus::portin,  PIO6::in93H },	// C[W
		{ 0x98, IOBus::portin,  PIO6::in90H },	// C[W
		{ 0x9a, IOBus::portin,  PIO6::in92H },	// C[W
		{ 0x9b, IOBus::portin,  PIO6::in93H },	// C[W
		{ 0x9c, IOBus::portin,  PIO6::in90H },	// C[W
		{ 0x9e, IOBus::portin,  PIO6::in92H },	// C[W
		{ 0x9f, IOBus::portin,  PIO6::in93H },	// C[W
		{ 0, 0, 0 }	};
	if( !io->Connect( pio, c_8255 ) ) return FALSE;
	
	// 8255(SUB CPU) -----
	const static IOBus::Connector c_8255s[] = {
		{ IO8049_BUS, IOBus::portout, PIO6::outPBH },
		{ IO8049_BUS, IOBus::portin,  PIO6::inPBH  },
		{ IO8049_T0,  IOBus::portin,  PIO6::inIBF  },
		{ IO8049_INT, IOBus::portin,  PIO6::inOBF  },
		{ 0, 0, 0 }	};
	if( !ios->Connect( pio, c_8255s ) ) return FALSE;
	
	// DISK -----
	if( disk->GetDrives() ){
		const static IOBus::Connector c_disk[] = {
			{ 0xd1, IOBus::portout, DSK60::outD1H },
			{ 0xd2, IOBus::portout, DSK60::outD2H },
			{ 0xd3, IOBus::portout, DSK60::outD3H },
			{ 0xd5, IOBus::portout, DSK60::outD1H },	// C[W
			{ 0xd6, IOBus::portout, DSK60::outD2H },	// C[W
			{ 0xd7, IOBus::portout, DSK60::outD3H },	// C[W
			{ 0xd9, IOBus::portout, DSK60::outD1H },	// C[W
			{ 0xda, IOBus::portout, DSK60::outD2H },	// C[W
			{ 0xdb, IOBus::portout, DSK60::outD3H },	// C[W
			{ 0xdd, IOBus::portout, DSK60::outD1H },	// C[W
			{ 0xde, IOBus::portout, DSK60::outD2H },	// C[W
			{ 0xdf, IOBus::portout, DSK60::outD3H },	// C[W
			{ 0xd0, IOBus::portin,  DSK60::inD0H },
			{ 0xd1, IOBus::portin,  DSK60::inD1H },
			{ 0xd2, IOBus::portin,  DSK60::inD2H },
			{ 0xd3, IOBus::portin,  DSK60::inD3H },
			{ 0xd4, IOBus::portin,  DSK60::inD0H },		// C[W
			{ 0xd5, IOBus::portin,  DSK60::inD1H },		// C[W
			{ 0xd6, IOBus::portin,  DSK60::inD2H },		// C[W
			{ 0xd7, IOBus::portin,  DSK60::inD3H },		// C[W
			{ 0xd8, IOBus::portin,  DSK60::inD0H },		// C[W
			{ 0xd9, IOBus::portin,  DSK60::inD1H },		// C[W
			{ 0xda, IOBus::portin,  DSK60::inD2H },		// C[W
			{ 0xdb, IOBus::portin,  DSK60::inD3H },		// C[W
			{ 0xdc, IOBus::portin,  DSK60::inD0H },		// C[W
			{ 0xdd, IOBus::portin,  DSK60::inD1H },		// C[W
			{ 0xde, IOBus::portin,  DSK60::inD2H },		// C[W
			{ 0xdf, IOBus::portin,  DSK60::inD3H },		// C[W
			{ 0, 0, 0 }	};
		if( !io->Connect( (DSK60*)disk, c_disk ) ) return FALSE;
		if( !disk->Init() ) return FALSE;
		// hCu1DISK}
		if( *(cfg->GetDiskFile()) ) disk->Mount( 0, cfg->GetDiskFile() );
	}
	
	// CMT(LOAD) -----
	const static IOBus::Connector c_cmt[] = {
		{ 0xb0, IOBus::portout, CMTL::outB0H },
		{ 0xb1, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xb2, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xb3, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xb4, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xb5, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xb6, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xb7, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xb8, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xb9, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xba, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xbb, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xbc, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xbd, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xbe, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0xbf, IOBus::portout, CMTL::outB0H },	// C[W
		{ 0, 0, 0 }	};
	if( !io->Connect( cmt, c_cmt ) ) return FALSE;
	
	// IvV@\ -----
	// m̃J[gbWΉ
	if( cfg->GetUseSoldier() ){
		const static IOBus::Connector c_soldier[] = {
			{ 0x7f, IOBus::portout, MEM60::out7FH },
			{ 0, 0, 0 }	};
		if( !io->Connect( (MEM60*)mem, c_soldier ) ) return FALSE;
	}
	
	
	Reset();
	
	// XN[TCYύX
	graph->ResizeScreen();
	
	// G[Ȃ
	Error::SetError( Error::NoError );
	
	return TRUE;
}

BOOL VM62::Init( const cConfig *config )
{
	// G[bZ[Wl
	Error::SetError( Error::InitFailed );
	
	if( !config ) return FALSE;
	cfg = (cConfig *)config;
	
	// eIuWFNgm
	intr   = new INT62( this, DEV_ID('I', 'N', 'T', 'R') );		// 
	sche   = new SCH6 ( this, DEV_ID('S', 'C', 'H', 'E'), CPUM_CLOCK62 * cfg->GetOverClock() / 100 );		// XPW[
	mem    = new MEM62( DEV_ID('M', 'E', 'M', '1'), cfg->GetUseExtRam() );	// 
	vdg    = new VDG62( this, DEV_ID('V', 'D', 'G', '2') );		// VDG
	key    = new KEY6 ( this, DEV_ID('K', 'E', 'Y', 'B') );		// L[
	disk   = new DSK60( this, DEV_ID('D', 'I', 'S', 'K'), cfg->GetFddNum() );	// DISK
	voice  = new VCE6 ( this, DEV_ID('V', 'O', 'I', 'C') );		// 
	
	if( !intr || !sche || !mem || !vdg || !key || !disk || !voice )
		return FALSE;
	
	// ʕ
	if( !VM6::InitCommon() ) return FALSE;
	
	// eIuWFNgƃfoCXڑ
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, INT62::outB0H },
		{ 0xf3, IOBus::portout, INT62::outF3H },
		{ 0xf4, IOBus::portout, INT62::outF4H },
		{ 0xf5, IOBus::portout, INT62::outF5H },
		{ 0xf6, IOBus::portout, INT62::outF6H },
		{ 0xf7, IOBus::portout, INT62::outF7H },
		{ 0xf3, IOBus::portin,  INT62::inF3H },
		{ 0xf4, IOBus::portin,  INT62::inF4H },
		{ 0xf5, IOBus::portin,  INT62::inF5H },
		{ 0xf6, IOBus::portin,  INT62::inF6H },
		{ 0xf7, IOBus::portin,  INT62::inF7H },
		{ 0, 0, 0 }	};
	if( !io->Connect( (INT62*)intr, c_intr ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_memory[] = {
		{ 0xc1, IOBus::portout, MEM62::outC1H },
		{ 0xc2, IOBus::portout, MEM62::outC2H },
		{ 0xc3, IOBus::portout, MEM62::outC3H },
		{ 0xf0, IOBus::portout, MEM62::outF0H },
		{ 0xf1, IOBus::portout, MEM62::outF1H },
		{ 0xf2, IOBus::portout, MEM62::outF2H },
		{ 0xf3, IOBus::portout, MEM62::outF3H },
		{ 0xf0, IOBus::portin,  MEM62::inF0H },
		{ 0xf1, IOBus::portin,  MEM62::inF1H },
		{ 0xf2, IOBus::portin,  MEM62::inF2H },
		{ 0xf3, IOBus::portin,  MEM62::inF3H },
		{ 0, 0, 0 }	};
	if( !io->Connect( (MEM62*)mem, c_memory ) ) return FALSE;
	
	// VDG -----
	const static IOBus::Connector c_vdg[] = {
		{ 0xb0, IOBus::portout, VDG62::outB0H },
		{ 0xc0, IOBus::portout, VDG62::outC0H },
		{ 0xc1, IOBus::portout, VDG62::outC1H },
		{ 0xc1, IOBus::portin,  VDG62::inC1H },
		{ 0, 0, 0 } };
	if( !io->Connect( (VDG62*)vdg, c_vdg ) ) return FALSE;
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, PSG6::outA0H },
		{ 0xa1, IOBus::portout, PSG6::outA1H },
		{ 0xa3, IOBus::portout, PSG6::outA3H },
		{ 0xa2, IOBus::portin,  PSG6::inA2H },
		{ 0, 0, 0 }	};
	if( !io->Connect( psg, c_psg ) ) return FALSE;
	int i=0;
	while( c_psg[i].bank ){						// EFCgݒ
		if( c_psg[i].rule == IOBus::portout ) io->SetOutWait( c_psg[i].bank, 1 );
		else								  io->SetInWait( c_psg[i].bank, 1 );
		i++;
	}
	if( !psg->Init( PSG_CLOCK62, snd->GetSampleRate() ) ) return FALSE;
	
	// 8255(Z80) -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, PIO6::out90H },
		{ 0x91, IOBus::portout, PIO6::out91H },
		{ 0x92, IOBus::portout, PIO6::out92H },
		{ 0x93, IOBus::portout, PIO6::out93H },
		{ 0x90, IOBus::portin,  PIO6::in90H },
		{ 0x92, IOBus::portin,  PIO6::in92H },
		{ 0x93, IOBus::portin,  PIO6::in93H },
		{ 0, 0, 0 }	};
	if( !io->Connect( pio, c_8255 ) ) return FALSE;
	
	// 8255(SUB CPU) -----
	const static IOBus::Connector c_8255s[] = {
		{ IO8049_BUS, IOBus::portout, PIO6::outPBH },
		{ IO8049_BUS, IOBus::portin,  PIO6::inPBH  },
		{ IO8049_T0,  IOBus::portin,  PIO6::inIBF  },
		{ IO8049_INT, IOBus::portin,  PIO6::inOBF  },
		{ 0, 0, 0 }	};
	if( !ios->Connect( pio, c_8255s ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_voice[] = {
		{ 0xe0, IOBus::portout, VCE6::outE0H },
		{ 0xe2, IOBus::portout, VCE6::outE2H },
		{ 0xe3, IOBus::portout, VCE6::outE3H },
		{ 0xe4, IOBus::portout, VCE6::outE0H },	// C[W
		{ 0xe6, IOBus::portout, VCE6::outE2H },	// C[W
		{ 0xe7, IOBus::portout, VCE6::outE3H },	// C[W
		{ 0xe8, IOBus::portout, VCE6::outE0H },	// C[W
		{ 0xea, IOBus::portout, VCE6::outE2H },	// C[W
		{ 0xeb, IOBus::portout, VCE6::outE3H },	// C[W
		{ 0xec, IOBus::portout, VCE6::outE0H },	// C[W
		{ 0xee, IOBus::portout, VCE6::outE2H },	// C[W
		{ 0xef, IOBus::portout, VCE6::outE3H },	// C[W
		{ 0xe0, IOBus::portin,  VCE6::inE0H },
		{ 0xe2, IOBus::portin,  VCE6::inE2H },
		{ 0xe3, IOBus::portin,  VCE6::inE3H },
		{ 0xe4, IOBus::portin,  VCE6::inE0H },	// C[W
		{ 0xe6, IOBus::portin,  VCE6::inE2H },	// C[W
		{ 0xe7, IOBus::portin,  VCE6::inE3H },	// C[W
		{ 0xe8, IOBus::portin,  VCE6::inE0H },	// C[W
		{ 0xea, IOBus::portin,  VCE6::inE2H },	// C[W
		{ 0xeb, IOBus::portin,  VCE6::inE3H },	// C[W
		{ 0xec, IOBus::portin,  VCE6::inE0H },	// C[W
		{ 0xee, IOBus::portin,  VCE6::inE2H },	// C[W
		{ 0xef, IOBus::portin,  VCE6::inE3H },	// C[W
		{ 0, 0, 0 }	};
	if( !io->Connect( voice, c_voice ) ) return FALSE;
	if( !voice->Init( snd->GetSampleRate(), cfg->GetWavePath() ) ) return FALSE;
	snd->ConnectStream( (SndDev *)voice );	// Xg[ڑ
	voice->SetVolume( cfg->GetVoiceVol() );	// ʐݒ
	
	// DISK -----
	if( disk->GetDrives() ){
		const static IOBus::Connector c_disk[] = {
			{ 0xd1, IOBus::portout, DSK60::outD1H },
			{ 0xd2, IOBus::portout, DSK60::outD2H },
			{ 0xd3, IOBus::portout, DSK60::outD3H },
			{ 0xd5, IOBus::portout, DSK60::outD1H },	// C[W
			{ 0xd6, IOBus::portout, DSK60::outD2H },	// C[W
			{ 0xd7, IOBus::portout, DSK60::outD3H },	// C[W
			{ 0xd9, IOBus::portout, DSK60::outD1H },	// C[W
			{ 0xda, IOBus::portout, DSK60::outD2H },	// C[W
			{ 0xdb, IOBus::portout, DSK60::outD3H },	// C[W
			{ 0xdd, IOBus::portout, DSK60::outD1H },	// C[W
			{ 0xde, IOBus::portout, DSK60::outD2H },	// C[W
			{ 0xdf, IOBus::portout, DSK60::outD3H },	// C[W
			{ 0xd0, IOBus::portin,  DSK60::inD0H },
			{ 0xd1, IOBus::portin,  DSK60::inD1H },
			{ 0xd2, IOBus::portin,  DSK60::inD2H },
			{ 0xd3, IOBus::portin,  DSK60::inD3H },
			{ 0xd4, IOBus::portin,  DSK60::inD0H },		// C[W
			{ 0xd5, IOBus::portin,  DSK60::inD1H },		// C[W
			{ 0xd6, IOBus::portin,  DSK60::inD2H },		// C[W
			{ 0xd7, IOBus::portin,  DSK60::inD3H },		// C[W
			{ 0xd8, IOBus::portin,  DSK60::inD0H },		// C[W
			{ 0xd9, IOBus::portin,  DSK60::inD1H },		// C[W
			{ 0xda, IOBus::portin,  DSK60::inD2H },		// C[W
			{ 0xdb, IOBus::portin,  DSK60::inD3H },		// C[W
			{ 0xdc, IOBus::portin,  DSK60::inD0H },		// C[W
			{ 0xdd, IOBus::portin,  DSK60::inD1H },		// C[W
			{ 0xde, IOBus::portin,  DSK60::inD2H },		// C[W
			{ 0xdf, IOBus::portin,  DSK60::inD3H },		// C[W
			{ 0, 0, 0 }	};
		if( !io->Connect( (DSK60*)disk, c_disk ) ) return FALSE;
		if( !disk->Init() ) return FALSE;
		// hCu1DISK}
		if( *(cfg->GetDiskFile()) ) disk->Mount( 0, cfg->GetDiskFile() );
	}
	
	// CMT(LOAD) -----
	const static IOBus::Connector c_cmt[] = {
		{ 0xb0, IOBus::portout, CMTL::outB0H },
		{ 0, 0, 0 }	};
	if( !io->Connect( cmt, c_cmt ) ) return FALSE;
	
	// IvV@\ -----
	// m̃J[gbWΉ
	if( cfg->GetUseSoldier() ){
		const static IOBus::Connector c_soldier[] = {
			{ 0x7f, IOBus::portout, MEM62::out7FH },
			{ 0, 0, 0 }	};
		if( !io->Connect( (MEM62*)mem, c_soldier ) ) return FALSE;
	}
	
	
	Reset();
	
	// XN[TCYύX
	graph->ResizeScreen();
	
	// G[Ȃ
	Error::SetError( Error::NoError );
	
	return TRUE;
}

BOOL VM66::Init( const cConfig *config )
{
	// G[bZ[Wl
	Error::SetError( Error::InitFailed );
	
	if( !config ) return FALSE;
	cfg = (cConfig *)config;
	
	// eIuWFNgm
	intr   = new INT62( this, DEV_ID('I', 'N', 'T', 'R') );		// 
	sche   = new SCH6 ( this, DEV_ID('S', 'C', 'H', 'E'), CPUM_CLOCK62 * cfg->GetOverClock() / 100 );		// XPW[
	mem    = new MEM66( DEV_ID('M', 'E', 'M', '1'), cfg->GetUseExtRam() );	// 
	vdg    = new VDG62( this, DEV_ID('V', 'D', 'G', '2') );		// VDG
	key    = new KEY6 ( this, DEV_ID('K', 'E', 'Y', 'B') );		// L[
	disk   = new DSK66( this, DEV_ID('D', 'I', 'S', 'K'), cfg->GetFddNum() );	// DISK
	voice  = new VCE6 ( this, DEV_ID('V', 'O', 'I', 'C') );		// 
	
	if( !intr || !sche || !mem || !vdg || !key || !disk || !voice )
		return FALSE;
	
	// ʕ
	if( !VM6::InitCommon() ) return FALSE;
	
	// eIuWFNgƃfoCXڑ
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, INT62::outB0H },
		{ 0xf3, IOBus::portout, INT62::outF3H },
		{ 0xf4, IOBus::portout, INT62::outF4H },
		{ 0xf5, IOBus::portout, INT62::outF5H },
		{ 0xf6, IOBus::portout, INT62::outF6H },
		{ 0xf7, IOBus::portout, INT62::outF7H },
		{ 0xf3, IOBus::portin,  INT62::inF3H },
		{ 0xf4, IOBus::portin,  INT62::inF4H },
		{ 0xf5, IOBus::portin,  INT62::inF5H },
		{ 0xf6, IOBus::portin,  INT62::inF6H },
		{ 0xf7, IOBus::portin,  INT62::inF7H },
		{ 0, 0, 0 }	};
	if( !io->Connect( (INT62*)intr, c_intr ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_memory[] = {
		{ 0xc1, IOBus::portout, MEM62::outC1H },
		{ 0xc2, IOBus::portout, MEM62::outC2H },
		{ 0xc3, IOBus::portout, MEM62::outC3H },
		{ 0xf0, IOBus::portout, MEM62::outF0H },
		{ 0xf1, IOBus::portout, MEM62::outF1H },
		{ 0xf2, IOBus::portout, MEM62::outF2H },
		{ 0xf3, IOBus::portout, MEM62::outF3H },
		{ 0xf0, IOBus::portin,  MEM62::inF0H },
		{ 0xf1, IOBus::portin,  MEM62::inF1H },
		{ 0xf2, IOBus::portin,  MEM62::inF2H },
		{ 0xf3, IOBus::portin,  MEM62::inF3H },
		{ 0, 0, 0 }	};
	if( !io->Connect( (MEM66*)mem, c_memory ) ) return FALSE;
	
	// VDG -----
	const static IOBus::Connector c_vdg[] = {
		{ 0xb0, IOBus::portout, VDG62::outB0H },
		{ 0xc0, IOBus::portout, VDG62::outC0H },
		{ 0xc1, IOBus::portout, VDG62::outC1H },
		{ 0xc1, IOBus::portin,  VDG62::inC1H },
		{ 0, 0, 0 } };
	if( !io->Connect( (VDG62*)vdg, c_vdg ) ) return FALSE;
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, PSG6::outA0H },
		{ 0xa1, IOBus::portout, PSG6::outA1H },
		{ 0xa3, IOBus::portout, PSG6::outA3H },
		{ 0xa2, IOBus::portin,  PSG6::inA2H },
		{ 0, 0, 0 }	};
	if( !io->Connect( psg, c_psg ) ) return FALSE;
	int i=0;
	while( c_psg[i].bank ){						// EFCgݒ
		if( c_psg[i].rule == IOBus::portout ) io->SetOutWait( c_psg[i].bank, 1 );
		else								  io->SetInWait( c_psg[i].bank, 1 );
		i++;
	}
	if( !psg->Init( PSG_CLOCK62, snd->GetSampleRate() ) ) return FALSE;
	
	// 8255(Z80) -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, PIO6::out90H },
		{ 0x91, IOBus::portout, PIO6::out91H },
		{ 0x92, IOBus::portout, PIO6::out92H },
		{ 0x93, IOBus::portout, PIO6::out93H },
		{ 0x90, IOBus::portin,  PIO6::in90H },
		{ 0x92, IOBus::portin,  PIO6::in92H },
		{ 0x93, IOBus::portin,  PIO6::in93H },
		{ 0, 0, 0 }	};
	if( !io->Connect( pio, c_8255 ) ) return FALSE;
	
	// 8255(SUB CPU) -----
	const static IOBus::Connector c_8255s[] = {
		{ IO8049_BUS, IOBus::portout, PIO6::outPBH },
		{ IO8049_BUS, IOBus::portin,  PIO6::inPBH  },
		{ IO8049_T0,  IOBus::portin,  PIO6::inIBF  },
		{ IO8049_INT, IOBus::portin,  PIO6::inOBF  },
		{ 0, 0, 0 }	};
	if( !ios->Connect( pio, c_8255s ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_voice[] = {
		{ 0xe0, IOBus::portout, VCE6::outE0H },
		{ 0xe2, IOBus::portout, VCE6::outE2H },
		{ 0xe3, IOBus::portout, VCE6::outE3H },
		{ 0xe4, IOBus::portout, VCE6::outE0H },	// C[W
		{ 0xe6, IOBus::portout, VCE6::outE2H },	// C[W
		{ 0xe7, IOBus::portout, VCE6::outE3H },	// C[W
		{ 0xe8, IOBus::portout, VCE6::outE0H },	// C[W
		{ 0xea, IOBus::portout, VCE6::outE2H },	// C[W
		{ 0xeb, IOBus::portout, VCE6::outE3H },	// C[W
		{ 0xec, IOBus::portout, VCE6::outE0H },	// C[W
		{ 0xee, IOBus::portout, VCE6::outE2H },	// C[W
		{ 0xef, IOBus::portout, VCE6::outE3H },	// C[W
		{ 0xe0, IOBus::portin,  VCE6::inE0H },
		{ 0xe2, IOBus::portin,  VCE6::inE2H },
		{ 0xe3, IOBus::portin,  VCE6::inE3H },
		{ 0xe4, IOBus::portin,  VCE6::inE0H },	// C[W
		{ 0xe6, IOBus::portin,  VCE6::inE2H },	// C[W
		{ 0xe7, IOBus::portin,  VCE6::inE3H },	// C[W
		{ 0xe8, IOBus::portin,  VCE6::inE0H },	// C[W
		{ 0xea, IOBus::portin,  VCE6::inE2H },	// C[W
		{ 0xeb, IOBus::portin,  VCE6::inE3H },	// C[W
		{ 0xec, IOBus::portin,  VCE6::inE0H },	// C[W
		{ 0xee, IOBus::portin,  VCE6::inE2H },	// C[W
		{ 0xef, IOBus::portin,  VCE6::inE3H },	// C[W
		{ 0, 0, 0 }	};
	if( !io->Connect( voice, c_voice ) ) return FALSE;
	if( !voice->Init( snd->GetSampleRate(), cfg->GetWavePath() ) ) return FALSE;
	snd->ConnectStream( (SndDev *)voice );	// Xg[ڑ
	voice->SetVolume( cfg->GetVoiceVol() );	// ʐݒ
	
	// DISK -----
	const static IOBus::Connector c_disk[] = {
		{ 0xb1, IOBus::portout, DSK66::outB1H },
		{ 0xb2, IOBus::portout, DSK66::outB2H },
		{ 0xb3, IOBus::portout, DSK66::outB3H },
		{ 0xd0, IOBus::portout, DSK66::outD0H },
		{ 0xd1, IOBus::portout, DSK66::outD1H },
		{ 0xd2, IOBus::portout, DSK66::outD2H },
		{ 0xd3, IOBus::portout, DSK66::outD3H },
		{ 0xd6, IOBus::portout, DSK66::outD6H },
		{ 0xd8, IOBus::portout, DSK66::outD8H },
		{ 0xda, IOBus::portout, DSK66::outDAH },
		{ 0xdd, IOBus::portout, DSK66::outDDH },
		{ 0xde, IOBus::portout, DSK66::outDEH },
		{ 0xb2, IOBus::portin,  DSK66::inB2H },
		{ 0xd0, IOBus::portin,  DSK66::inD0H },
		{ 0xd1, IOBus::portin,  DSK66::inD1H },
		{ 0xd2, IOBus::portin,  DSK66::inD2H },
		{ 0xd3, IOBus::portin,  DSK66::inD3H },
		{ 0xd4, IOBus::portin,  DSK66::inD4H },
		{ 0xdc, IOBus::portin,  DSK66::inDCH },
		{ 0xdd, IOBus::portin,  DSK66::inDDH },
		{ 0, 0, 0 }	};
	if( !io->Connect( (DSK66*)disk, c_disk ) ) return FALSE;
	if( !disk->Init() ) return FALSE;
	// hCu1DISK}
	if( *(cfg->GetDiskFile()) ) disk->Mount( 0, cfg->GetDiskFile() );
	
	// CMT(LOAD) -----
	const static IOBus::Connector c_cmt[] = {
		{ 0xb0, IOBus::portout, CMTL::outB0H },
		{ 0, 0, 0 }	};
	if( !io->Connect( cmt, c_cmt ) ) return FALSE;
	
	// IvV@\ -----
	// m̃J[gbWΉ
	if( cfg->GetUseSoldier() ){
		const static IOBus::Connector c_soldier[] = {
			{ 0x7f, IOBus::portout, MEM62::out7FH },
			{ 0, 0, 0 }	};
		if( !io->Connect( (MEM66*)mem, c_soldier ) ) return FALSE;
	}
	
	
	Reset();
	
	// XN[TCYύX
	graph->ResizeScreen();
	
	// G[Ȃ
	Error::SetError( Error::NoError );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ʕ
////////////////////////////////////////////////////////////////
BOOL VM6::InitCommon( void )
{
	// eIuWFNgm
	io     = new IO6;											// I/O(Z80)
	ios    = new IO6;											// I/O(SUB CPU)
	snd    = new SND6;											// TEh
	cpum   = new CPU6 ( this, DEV_ID('C', 'P', 'U', '1') );		// CPU
	cpus   = new SUB6 ( this, DEV_ID('8', '0', '4', '9') );		// SUB CPU
	graph  = new DSP6 ( this, DEV_ID('D', 'I', 'S', 'P') );		// ʕ`
	psg    = new PSG6 ( this, DEV_ID('P', 'S', 'G', '1') );		// PSG
	pio    = new PIO6 ( this, DEV_ID('8', '2', '5', '5') );		// 8255
	cmt    = new CMTL ( this, DEV_ID('T', 'A', 'P', 'E') );		// CMT(LOAD)
	cmts   = new CMTS ( this, DEV_ID('S', 'A', 'V', 'E') );		// CMT(SAVE)
	staw   = new cWndStat( this, DEV_ID('S', 'T', 'A', 'W') );	// Xe[^Xo[
	joy    = new cJoy;
	
	if( !io  || !ios || !snd || !cpum || !cpus || !graph ||
		!psg || !pio || !cmt || !cmts || !staw || !joy )
			return FALSE;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	bp     = new BPoint();										// u[N|Cg
	regw   = new cWndReg( this, DEV_ID('R', 'E', 'G', 'W') );	// WX^EBhE
	memw   = new cWndMem( this, DEV_ID('M', 'E', 'M', 'W') );	// EBhE
	monw   = new cWndMon( this, DEV_ID('M', 'O', 'N', 'W') );	// j^EBhE
	
	if( !bp || !regw || !memw || !monw ) return FALSE;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// R\[ptHgǍ
	if( !JFont::OpenFont( cfg->GetFontFileZ(), cfg->GetFontFileH() ) ){
		Error::SetError( Error::FontFailed );
		return FALSE;
	}
	
	// pbg
	for( int i=0; i<128; i++ ){
		cfg->GetColor( i, &GPal[i] );
		
		// XLCpJ[ݒ
		GPal[i+128].r = ( GPal[i].r * cfg->GetScanLineBr() ) / 100;
		GPal[i+128].g = ( GPal[i].g * cfg->GetScanLineBr() ) / 100;
		GPal[i+128].b = ( GPal[i].b * cfg->GetScanLineBr() ) / 100;
	}
	
	// OSD֘A
	if( !OSD_Init() ) return FALSE;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// u[N|Cg@-----
	bp->ClearStatus();
	
	// WX^EBhE@-----
	if( !regw->Init() ) return FALSE;
	
	// EBhE@-----
	if( !memw->Init() ) return FALSE;
	
	// j^EBhE@-----
	if( !monw->Init() ) return FALSE;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// I/O(Z80)@-----
	if( !io->Init( 256 ) ) return FALSE;
	
	// I/O(SUB CPU)@-----
	if( !ios->Init( 10 ) ) return FALSE;
	
	//  -----
	intr->Reset();
	
	// XPW[ -----
	if( !sche->Init() ) return FALSE;
	
	// TEh -----
	if( !snd->Init( this, VM6::StreamUpdate, cfg->GetSampleRate(), cfg->GetSoundBuffer() ) ) return FALSE;
	snd->SetVolume( cfg->GetMasterVol() );
	
	// CPU -----
	cpum->Reset();
	
	// SUB CPU -----
	cpus->Reset();
	
	//  -----
	if( !mem->Init( cfg->GetRomPath(), cfg->GetCheckCRC(), cfg->GetUseSoldier() ) ) return FALSE;
	if( cfg->GetRomPatch() ) mem->Patch();
	if( *(cfg->GetExtRomFile()) ) if( !mem->MountExtRom( cfg->GetExtRomFile() ) ) return FALSE;
	
	// VDG -----
	if( !vdg->Init() ) return FALSE;
	vdg->SetPalette( GPal );				// Ô߃pbgݒ
	vdg->SetMode4Color( cfg->GetMode4Color() );
	
	// ʕ` -----
	if( !graph->Init( cfg->GetScrBpp(), cfg->GetScanLineBr(), GPal ) ) return FALSE;
	
	// PSG -----
	snd->ConnectStream( (SndDev *)psg );	// Xg[ڑ
	psg->SetVolume( cfg->GetPsgVol() );		// ʐݒ
	psg->SetLPF( cfg->GetPsgLPF() );		// [pXtB^ JbgItgݒ
	
	// 8255 -----
	pio->Reset();
	
	// L[ -----
	if( !key->Init( cfg->GetKeyRepeat() ) ) return FALSE;
	VKeyConv *vk;
	if( cfg->GetVKeyDef( &vk ) )	// L[`z擾
		key->SetVKeySymbols( vk );	// zL[R[h -> P6L[R[h ݒ
	
	// CMT(LOAD) -----
	if( !cmt->Init( snd->GetSampleRate() ) ) return FALSE;
	snd->ConnectStream( (SndDev *)cmt );	// Xg[ڑ
	cmt->SetVolume( cfg->GetCmtVol() );		// ʐݒ
	cmt->SetLPF( DEFAULT_TAPELPF );			// [pXtB^ JbgItgݒ
	cmt->SetBoost( cfg->GetBoostUp() );
	cmt->SetMaxBoost( cfg->GetMaxBoost1(), cfg->GetMaxBoost2() );
	
	// TAPE}
	if( *(cfg->GetTapeFile()) ) cmt->Mount( cfg->GetTapeFile() );
	
	// CMT(SAVE) -----
	if( !cmts->Init( cfg->GetSaveFile() ) ) return FALSE;
	
	// Xe[^Xo[ -----
	if( !staw->Init( SDL_GetVideoSurface()->w ) ) return FALSE;
	
	// WCXeBbN -----
	joy->Init();
	
	// FPS\^C}ݒ
	if( !SetFPSTimer( 1 ) ){
		Stop();
		return FALSE;
	}
	
	// rfILv` -----
	if( !AVI6::Init() ) return FALSE;
	
	// vC -----
	if( !REPLAY::Init( key->GetMatrixSize() ) ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// Jn
////////////////////////////////////////////////////////////////
BOOL VM6::Start( void )
{
	FSkipCount = 0;
	
	// Xbh
	if( !this->cThread::BeginThread( this ) ) return FALSE;
	
	sche->Start();
	snd->Play();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ~
////////////////////////////////////////////////////////////////
void VM6::Stop( void )
{
	this->cThread::Cancel();	// XbhItOĂ
	this->cThread::Waiting();	// XbhI܂ő҂
	
	snd->Pause();
	sche->Stop();
	
	FSkipCount = 0;
}


////////////////////////////////////////////////////////////////
// Zbg
////////////////////////////////////////////////////////////////
void VM6::Reset( void )
{
	cpum->Reset();
	intr->Reset();
	mem->Reset();
	cpus->Reset();
	pio->Reset();
	psg->Reset();
	disk->Init();
	cmt->Reset();
	// VXefBXNĂTAPẼI[gX^[g
	if( !disk->IsSystem(0) && !disk->IsSystem(1) ) cmt->SetAutoStart( cfg->GetModel() );
	if( voice ) voice->Reset();
}


////////////////////////////////////////////////////////////////
// Cxg[v
////////////////////////////////////////////////////////////////
VM6::ReturnCode VM6::EventLoop( void )
{
	SDL_Event event;
	
	while( SDL_WaitEvent( &event ) ){
		switch( event.type ){
		case SDL_FPSUPDATE:		// FPS\
			{
			char str[256];
			sprintf( str, "%s (%d%%  %d/%d fps)", cfg->GetCaption(), sche->GetRatio(), event.user.code, FRAMERATE );
			SDL_WM_SetCaption( str, "" );
			}
			break;
			
		case SDL_KEYDOWN:		// L[
			#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			// j^[h?
			if( cfg->GetMonDisp() ){
				monw->KeyIn( OSD_ConvertKeyCode( event.key.keysym.sym ), event.key.keysym.mod & KMOD_SHIFT, event.key.keysym.unicode );
				break;
			}else
			#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			// e@\L[`FbN
			if( CheckFuncKey( &event ) ) break;
			// vCĐ or L[͎słȂ
			if( REPLAY::GetStatus() != REP_REPLAY && !IsAutoKey() )
				// L[}gNXXV(L[)
				key->UpdateMatrixKey( OSD_ConvertKeyCode( event.key.keysym.sym ), TRUE );
			break;
			
		case SDL_KEYUP:
			// vCĐ or L[͎słȂ
			if( REPLAY::GetStatus() != REP_REPLAY && !IsAutoKey() )
				// L[}gNXXV(L[)
				key->UpdateMatrixKey( OSD_ConvertKeyCode( event.key.keysym.sym ), FALSE );
			break;
			
		case SDL_JOYAXISMOTION:
		case SDL_JOYBUTTONDOWN:
		case SDL_JOYBUTTONUP:
			// vCĐ or L[͎słȂ
			if( REPLAY::GetStatus() != REP_REPLAY && !IsAutoKey() )
				// L[}gNXXV(WCXeBbN)
				key->UpdateMatrixJoy();
			break;
			
		#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		case SDL_DEBUGMODEBP:	// j^[hύX(u[N|CgB)
			monw->BreakIn( event.user.code );	// u[N|Cg̏\
			ToggleMonitor();					// j^[hύX
			
			break;
			
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		case SDL_MOUSEBUTTONUP:	// }EX{^NbN
			if( ( event.button.button == SDL_BUTTON_RIGHT ) && ( event.button.state == SDL_RELEASED ) ){
				Stop();
				
				// |bvAbvj[\
				ShowPopupMenu( event.button.x, event.button.y );
				
				Start();
			}
			break;
			
		case SDL_QUIT:			// I
			if( cfg->GetCkQuit() )
				if( OSD_Message( MSG_QUIT, MSG_QUITC, OSDM_YESNO | OSDM_ICONQUESTION ) != OSDR_YES )
					break;
			return Quit;
			
		case SDL_RESTART:		// ċN
			return Restart;
		}
		
		// G[
//		if( Error::GetError() != Error::NoError ){
//			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
//			Error::SetError( Error::NoError );
//		}
		switch( Error::GetError() ){
		case Error::NoError:
			break;
			
		case Error::DokoDiffModel:
			Error::SetError( Error::NoError );
			return Doko;
			
		case Error::ReplayDiffModel:
			Error::SetError( Error::NoError );
			return Replay;
			
		default:
			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			Error::SetError( Error::NoError );
		}
	}
	return Quit;
}


////////////////////////////////////////////////////////////////
// e@\L[`FbN
////////////////////////////////////////////////////////////////
BOOL VM6::CheckFuncKey( SDL_Event *event )
{
	// ALTL[̏Ԃ擾
	BOOL OnALT  = event->key.keysym.mod & KMOD_ALT  ? TRUE : FALSE;
#ifdef __APPLE__
	// METAL[̏Ԃ擾
	BOOL OnMETA = event->key.keysym.mod & KMOD_META ? TRUE : FALSE;
#endif
	
	switch( event->key.keysym.sym ){	// L[R[h
	case SDLK_F6:		// j^[hύX or XN[[hύX
		// rfILv`͖
		if( AVI6::IsAVI() ) return FALSE;
		
		if( OnALT ){
			Stop();
			cfg->SetFullScreen( cfg->GetFullScreen() ? FALSE : TRUE );
			graph->ResizeScreen();	// XN[TCYύX
			Start();
		}else{
			#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			ToggleMonitor();
			#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		}
		break;
		
	case SDLK_F7:			// XLC[hύX
		// rfILv`͖
		if( AVI6::IsAVI() ) return FALSE;
		
		Stop();
		if( OnALT ){
			cfg->SetDispNTSC( cfg->GetDispNTSC() ? FALSE : TRUE );
		}else{
			cfg->SetScanLine( cfg->GetScanLine() ? FALSE : TRUE );
		}
		graph->ResizeScreen();	// XN[TCYύX
		Start();
		break;
		
	case SDLK_F8:			// [h4J[ύX or Xe[^Xo[\ԕύX
		if( OnALT ){
			Stop();
			cfg->SetStatDisp( cfg->GetStatDisp() ? FALSE : TRUE );
			graph->ResizeScreen();	// XN[TCYύX
			Start();
		}else{
			int c = vdg->GetMode4Color();
			if( ++c > 4 ) c = 0;
			vdg->SetMode4Color( c );
		}
		break;
		
	case SDLK_F10:			// WaitLύX
		if( OnALT ){
		}else{
			sche->SetWaitEnable( sche->GetWaitEnable() ? FALSE : TRUE );
		}
		break;
		
	case SDLK_F11:			// Zbg or ċN
		if( OnALT ){
			SENDEVENT( SDL_RESTART )
		}else{
			Reset();
		}
		break;
		
	case SDLK_F12:			// XibvVbg
		if( OnALT ){
		}else{
			graph->SnapShot( cfg->GetImgPath() );
		}
		break;
		
#ifdef __APPLE__
	// Mac ł Cmd(Meta)+Q AvP[V̏I (by Windy)
	case SDLK_q:
		if( OnMETA ){
			SENDEVENT( SDL_QUIT );
			break;	// break ȂƁACmd+Q ƂɁAQ ͂Ă܂B   add Windy  2007/4/24
		}
		
	// Cmd(Meta){SpacełAȃL[Ƃē삳B(by Windyj
	case SDLK_SPACE:
		if( OnMETA ){
			event->key.keysym.sym = SDLK_PAUSE;
		}
#endif
		
	default:				// ǂłȂ
		return FALSE;
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ʍXV
////////////////////////////////////////////////////////////////
BOOL VM6::ScreenUpdate( void )
{
	// t[XLbv`FbN
	if( ++FSkipCount > cfg->GetFrameSkip() ){
		vdg->UpdateBackBuf();	// obNobt@XV
		graph->DrawScreen();	// ʕ`
		
		#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		if( cfg->GetMonDisp() ){
			regw->Update();
			memw->Update();
			monw->Update();
		}
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		
		UDFPSCount++;
		FSkipCount = 0;
		
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// TEhXV
//
// :	samples		XVTv(-1:cobt@S 0:NbN)
//			exbuf		Oobt@
// Ԓl:	int			XVTv
////////////////////////////////////////////////////////////////
int VM6::SoundUpdate( int samples, cRing *exbuf )
{
	// PSGXV
	psg->SoundUpdate( samples );
	
	// XV
//	if( voice ) voice->SoundUpdate( samples );
	
	// TEhobt@XV
	return snd->PreUpdate( psg->SndDev::cRing::ReadySize(), exbuf );
}


////////////////////////////////////////////////////////////////
// Xg[XV R[obN֐
//
// :	userdata	gւ̃IuWFNg|C^
//			stream		Xg[݃obt@ւ̃|C^
//			len			obt@TCY(oCgP)
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void VM6::StreamUpdate( void *userdata, BYTE *stream, int len )
{
	VM6 *p6 = (VM6 *)userdata;			// g̃IuWFNg|C^擾
	
	// TEhobt@XV
	//  TvȂ΂Œǉ
	//  rfILv`͖
	int addsam = (int)(len/sizeof(Sint16)) - (int)(p6->snd->cRing::ReadySize());
	if( addsam > 0 && !p6->AVI6::IsAVI() ) p6->SoundUpdate( addsam );
	
	p6->snd->Update( stream, len/sizeof(Sint16) );
}


////////////////////////////////////////////////////////////////
// FPS\^C} R[obN֐
////////////////////////////////////////////////////////////////
Uint32 VM6::UpDateFPS( Uint32 interval, void *obj )
{
	VM6 *p6 = (VM6 *)obj;	// g̃IuWFNg|C^擾
	
	SENDEVENT1( SDL_FPSUPDATE, p6->UDFPSCount )
	p6->UDFPSCount = 0;
	
	return interval;
}


////////////////////////////////////////////////////////////////
// FPS\^C}ݒ
////////////////////////////////////////////////////////////////
BOOL VM6::SetFPSTimer( int fps )
{
	// ^C}ғȂ~
	if( UpDateFPSID ){
		SDL_RemoveTimer( UpDateFPSID );
		UpDateFPSID = NULL;
		SDL_EventState( SDL_FPSUPDATE, SDL_IGNORE );
	}
	
	// ^C}ݒ
	if( fps > 0 ){
		UpDateFPSID = SDL_AddTimer( 1000/fps, VM6::UpDateFPS, this );
		if( !UpDateFPSID ) return FALSE;
		
		SDL_EventState( SDL_FPSUPDATE, SDL_ENABLE );
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// L[͎s?
//
// :	Ȃ
// Ԓl:	BOOL	TRUE:s FALSE:słȂ
////////////////////////////////////////////////////////////////
BOOL VM6::IsAutoKey( void )
{
	return ak.Num ? TRUE : FALSE;
}


////////////////////////////////////////////////////////////////
// L[1擾
//   (VSYNC=1/60secɌĂ΂)
//
// :	Ȃ
// Ԓl:	BYTE	P6̃L[R[h
////////////////////////////////////////////////////////////////
char VM6::GetAutoKey( void )
{
	// [OFF҂
	if( ak.Relay ){
		if( cmt->IsRelay() ) return 0;
		else                 ak.Relay = FALSE;
	}
	
	// ҂?
	if( ak.Wait > 0 ){
		ak.Wait--;
		return 0;
	}
	
	// ̕擾
	if( ak.Num-- > 0 ){
		BYTE dat = ak.Buffer[ak.Seek++];
		switch( dat ){
		case 0x17:	// '\w' EFCgݒ
			if( ak.Num-- > 0 ) ak.Wait += (int)((BYTE)ak.Buffer[ak.Seek++]);	// ҂񐔐ݒ
			dat = 0;
			break;
			
		case 0x0a:	// '\r' [OFF҂
			ak.Relay = TRUE;
			dat = 0x0d;
		case 0x0d:	// '\n' s?
			ak.Wait = 9;	// ҂9(=150msec)
			break;
			
		default:	// ʂ̕
			ak.Wait = 0;	// ҂Ȃ
		}
		return dat;
	}else{
		// obt@ȂI
		delete [] ak.Buffer;
		ak.Buffer = NULL;
	}
	return 0;
}


////////////////////////////////////////////////////////////////
// L[͕ݒ
//
// :	str		
//			num		̒
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL VM6::SetAutoKey( char *str, int num )
{
	// L[obt@U폜
	
	// L[obt@m
	if( ak.Buffer ) delete [] ak.Buffer;
	ak.Buffer = new char[num+1];
	if( !ak.Buffer ){
		ak.Num = 0;
		return FALSE;
	}
	
	// Rs[
	strncpy( ak.Buffer, str, num );
	
	ak.Num    = num;	// c蕶
	ak.Wait   = 60;		// ҂񐔃JE^(1sec)
	ak.Relay  = FALSE;	// [XCb`OFF҂tO
	ak.Seek   = 0;		// Ǎ݃|C^
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// L[͕ݒ(t@C)
//
// :	filepath	̓t@Cւ̃pX
// Ԓl:	BOOL		TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL VM6::SetAutoKeyFile( char *filepath )
{
	FILE *fp;
	char lbuf[1024];
	
	fp = FOPENEN( filepath, "rb" );
	if( !fp ) return FALSE;
	
	fseek( fp, 0, SEEK_END );
	int tsize = ftell( fp ) + 1;
	fseek( fp, 0, SEEK_SET );
	
	// L[obt@m
	if( ak.Buffer ) delete [] ak.Buffer;
	ak.Buffer = new char[tsize+1];
	if( !ak.Buffer ){
		fclose( fp );
		ak.Num = 0;
		return FALSE;
	}
	ZeroMemory( ak.Buffer, sizeof(ak.Buffer) );
	
	// Ǎ
	// f[^Ȃ܂ŌJԂ
	while( fgets( lbuf, 1024, fp ) ){
		Sjis2P6( lbuf, lbuf );	// SJIS -> P6
		strcat( ak.Buffer, lbuf );
	}
	fclose( fp );
	tsize = strlen( ak.Buffer );
	
	ak.Num    = tsize;	// c蕶
	ak.Wait   = 60;		// ҂񐔃JE^(1sec)
	ak.Relay  = FALSE;	// [XCb`OFF҂tO
	ak.Seek   = 0;		// Ǎ݃|C^
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ǂłSAVE
//
// :	filename	t@C
// Ԓl:	BOOL		TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL VM6::DokoDemoSave( char *filename )
{
	cIni *Ini = NULL;
	
	// Ƃ肠G[ݒ
	Error::SetError( Error::DokoWriteFailed );
	try{
		FILE *fp = FOPENEN( filename, "wt" );
		if( !fp ) throw Error::DokoWriteFailed;
		// ^Cgso͂ĈU
		fprintf( fp, MSDOKO_TITLE );
		fclose( fp );
		
		// ǂłSAVEt@CJ
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::DokoWriteFailed;
		
		if( !cfg->DokoSave( Ini ) ||
			!sche->DokoSave( Ini ) ||
			!psg->DokoSave( Ini ) ||
			!disk->DokoSave( Ini ) ||
			!vdg->DokoSave( Ini ) ||
			!intr->DokoSave( Ini ) ||
			!key->DokoSave( Ini ) ||
			!cpus->DokoSave( Ini ) ||
			!pio->DokoSave( Ini ) ||
			!cpum->DokoSave( Ini ) ||
			!mem->DokoSave( Ini ) ||
			!cmt->DokoSave( Ini )
		) throw Error::GetError();
	}
	catch( std::bad_alloc ){	// new Ɏsꍇ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// O
		Error::SetError( i );
		if( Ini ) delete Ini;
		return FALSE;
	}
	
	Ini->Write();
	
	delete Ini;
	
	// ̂ŃG[Ȃ
	Error::SetError( Error::NoError );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ǂłLOAD
//
// :	filename	t@C
// Ԓl:	BOOL		TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL VM6::DokoDemoLoad( char *filename )
{
	cIni *Ini = NULL;
	
	// Ƃ肠G[ݒ
	Error::SetError( Error::DokoReadFailed );
	try{
		// ǂłLOADt@CJ
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::DokoReadFailed;
		cfg->SetDokoFile( filename );
		
		// ܂PC6001Ṽo[WƋ@mF
		if( !cfg->DokoLoad( Ini ) ) throw Error::GetError();
		
		Reset();
		
		if(	!sche->DokoLoad( Ini ) ||
			!psg->DokoLoad( Ini ) ||
			!disk->DokoLoad( Ini ) ||
			!vdg->DokoLoad( Ini ) ||
			!intr->DokoLoad( Ini ) ||
			!key->DokoLoad( Ini ) ||
			!cpus->DokoLoad( Ini ) ||
			!pio->DokoLoad( Ini ) ||
			!cpum->DokoLoad( Ini ) ||
			!mem->DokoLoad( Ini ) ||
			!cmt->DokoLoad( Ini )
		) throw Error::GetError();
	}
	catch( std::bad_alloc ){	// new Ɏsꍇ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// O
		Error::SetError( i );
		if( Ini ) delete Ini;
		return FALSE;
	}
	
	delete Ini;
	cfg->SetDokoFile( "" );
	
	// ̂ŃG[Ȃ
	Error::SetError( Error::NoError );
	
	return TRUE;
}




